{% extends "src/common/_layout.njk" %}

{%- set page_hide_breadcrumb = true -%}
{% set title = "4.0 Тревога" %}


{% block heading %}
    <div class="content-header justify-content-between d-flex flex-wrap align-items-center mb-1">
        <ol class="content-header__breadcrumb breadcrumb mb-50 mr-lg-4">
            <li class="breadcrumb-item">
                <a href="#">Тревога</a>
            </li>
        </ol>
        <div class="d-flex align-items-center justify-content-between flex-md-grow-1">
            <div class="btn-group d-none d-md-flex mb-50 justify-md-content-between">
                <button class="btn btn-outline-primary active">Тревога</button>
                <button class="btn btn-outline-primary">История</button>
            </div>
        </div>
    </div><!-- .content-header -->
{% endblock %}

{% block main %}

    <div class="card">
        <div class="card-body p-1 mb-0">
            <div class="comm">
                <div class="comm__map shadow">
                    <button id="draw" class="btn btn-secondary btn-sm comm__map--button">Выделить область</button>
                    <div id="container" class="comm__map--container">
                        <div id="map" class="comm__map--source"></div>
                        <canvas id="draw-canvas" class="comm__map--polygon" style="position: absolute; left: 0; top: 0; display: none;"></canvas>
                    </div>
                </div><!-- .comm__map -->
                <div class="comm__sidebar">
                    <div class="comm__main shadow">
                        <div class="comm__filter">
                            <select name="filter" class="select2">
                                <option value="1" selected>Все сотрудники: 348</option>
                                <option value="1">Отдел 1: 115</option>
                                <option value="1">Отдел 2: 100</option>
                                <option value="1">Отдел 3: 125</option>
                            </select>
                        </div><!-- .comm__filter -->
                        <div class="comm__content">
                            <div class="comm__content--wrap">
                                <div class="comm__content--source pretty-scroll">
                                    <ul class="comm__list">
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="all">
                                                <span class="pretty-checkbox__label">Выбрать всех </span>
                                            </label>
                                        </li>
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="1" checked>
                                                <span class="pretty-checkbox__label">Турсунханов Н.В.</span>
                                            </label>
                                        </li>
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="1">
                                                <span class="pretty-checkbox__label">Ахметов С.Г.</span>
                                            </label>
                                        </li>
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="1">
                                                <span class="pretty-checkbox__label">Омаров В.Н.</span>
                                            </label>
                                        </li>
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="1" checked>
                                                <span class="pretty-checkbox__label">Петров Н.Г.</span>
                                            </label>
                                        </li>
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="1">
                                                <span class="pretty-checkbox__label">Федоров С.Д.</span>
                                            </label>
                                        </li>
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="1">
                                                <span class="pretty-checkbox__label">Садыков С.Г.</span>
                                            </label>
                                        </li>
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="1">
                                                <span class="pretty-checkbox__label">Козлов В.П.</span>
                                            </label>
                                        </li>
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="1">
                                                <span class="pretty-checkbox__label">Кузьмин Э.С.</span>
                                            </label>
                                        </li>
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="1">
                                                <span class="pretty-checkbox__label">Абдуллаев А.М.</span>
                                            </label>
                                        </li>
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="1">
                                                <span class="pretty-checkbox__label">Султанов А.М.</span>
                                            </label>
                                        </li>
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="1">
                                                <span class="pretty-checkbox__label">Болат И.В.</span>
                                            </label>
                                        </li>
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="all">
                                                <span class="pretty-checkbox__label">Выбрать всех </span>
                                            </label>
                                        </li>
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="1" checked>
                                                <span class="pretty-checkbox__label">Турсунханов Н.В.</span>
                                            </label>
                                        </li>
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="1">
                                                <span class="pretty-checkbox__label">Ахметов С.Г.</span>
                                            </label>
                                        </li>
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="1">
                                                <span class="pretty-checkbox__label">Омаров В.Н.</span>
                                            </label>
                                        </li>
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="1" checked>
                                                <span class="pretty-checkbox__label">Петров Н.Г.</span>
                                            </label>
                                        </li>
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="1">
                                                <span class="pretty-checkbox__label">Федоров С.Д.</span>
                                            </label>
                                        </li>
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="1">
                                                <span class="pretty-checkbox__label">Садыков С.Г.</span>
                                            </label>
                                        </li>
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="1">
                                                <span class="pretty-checkbox__label">Козлов В.П.</span>
                                            </label>
                                        </li>
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="1">
                                                <span class="pretty-checkbox__label">Кузьмин Э.С.</span>
                                            </label>
                                        </li>
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="1">
                                                <span class="pretty-checkbox__label">Абдуллаев А.М.</span>
                                            </label>
                                        </li>
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="1">
                                                <span class="pretty-checkbox__label">Султанов А.М.</span>
                                            </label>
                                        </li>
                                        <li>
                                            <label class="pretty-checkbox">
                                                <input type="checkbox" name="ch1" class="pretty-checkbox__input" value="1">
                                                <span class="pretty-checkbox__label">Болат И.В.</span>
                                            </label>
                                        </li>
                                    </ul><!-- .comm__list -->
                                </div>
                            </div>
                        </div>
                    </div><!-- .comm__main -->
                    <div class="comm__title">Отправить выбранным сотрудникам сообщение</div>
                    <div class="comm__post p-1 shadow">
                        <div class="media mb-1">
                            <a class="mr-1" href="javascript:void(0);">
                                <img src="../../../app-assets/images/portrait/small/avatar-s-26.jpg" alt="users view avatar" class="users-avatar-shadow rounded-circle" height="64" width="64">
                            </a>
                            <div class="media-body pt-50">
                                <div class="d-flex flex-wrap">
                                    <a href="javascript:void(0);" class="btn btn-sm btn-secondary mr-25 text-nowrap  mb-25">Загрузить фото</a>
                                    <a href="javascript:void(0);" class="btn btn-sm btn-light-secondary  mb-25">Удалить</a>
                                </div>
                                <div class="font-size-small">JPG, Gif или PNG. Макс. размер файла 20mb</div>
                            </div>
                        </div>
                        <div class="form-group">
                            <textarea name="message" rows="4" class="form-control" placeholder="введите сообщение..."></textarea>
                        </div>
                        <button class="btn btn-primary">Отправить</button>
                    </div>
                </div><!-- .comm__sidebar -->
            </div><!-- .comm__ -->
        </div><!-- .card-body -->
    </div><!-- .card -->
{% endblock %}


{% block scripts %}
    <script src="https://api-maps.yandex.ru/2.1/?apikey=89e58c06-5d58-4418-99df-35829b46b183&lang=ru_RU" type="text/javascript"></script>

    <script>
        let polygonOptions = {
            strokeColor: '#0000ff',
            fillColor: '#8080ff',
            interactivityModel: 'default#transparent',
            strokeWidth: 4,
            opacity: 0.7
        };

        let canvasOptions = {
            strokeStyle: '#0000ff',
            lineWidth: 4,
            opacity: 0.7
        };

        ymaps.ready(['Map', 'Polygon']).then(function() {
            let map = new ymaps.Map('map', {
                center: [55.7721,37.6202],
                zoom: 14,
                controls: []
            });
            let polygon = null;

            let drawButton = document.querySelector('#draw');

            drawButton.onclick = function() {
                drawButton.disabled = true;

                drawLineOverMap(map)
                    .then(function(coordinates) {
                        // Переводим координаты из 0..1 в географические.
                        var bounds = map.getBounds();
                        coordinates = coordinates.map(function(x) {
                            return [
                                // Широта (latitude).
                                // Y переворачивается, т.к. на canvas'е он направлен вниз.
                                bounds[0][0] + (1 - x[1]) * (bounds[1][0] - bounds[0][0]),
                                // Долгота (longitude).
                                bounds[0][1] + x[0] * (bounds[1][1] - bounds[0][1]),
                            ];
                        });

                        // Тут надо симплифицировать линию.

                        coordinates = coordinates.filter(function(_, index) {
                            return index % 3 === 0;
                        });

                        // Удаляем старый полигон.
                        if (polygon) {
                            map.geoObjects.remove(polygon);
                        }

                        // Создаем новый полигон
                        polygon = new ymaps.Polygon([coordinates], {}, polygonOptions);
                        map.geoObjects.add(polygon);

                        drawButton.disabled = false;
                    });
            };

            let userLayout_1 = ymaps.templateLayoutFactory.createClass('<div class="point">' +
                '<div class="point__avatar"><img src="assets/img/content/user_01.png" class="img-fluid" alt=""></div>' +
                '<div class="point__content">' +
                '<div class="point__name">Искаков А.Н.</div>' +
                '</div>' +
                '</div>'
            );

            let user_1 = new ymaps.Placemark(
                [55.7615,37.6204], {
                    hintContent: 'Искаков А.Н.'
                }, {
                    iconLayout: userLayout_1,
                    iconShape: {
                        type: 'Rectangle',
                        coordinates: [
                            [-25, -25], [25, 25]
                        ]
                    }
                }
            );

            let userLayout_2 = ymaps.templateLayoutFactory.createClass('<div class="point">' +
                '<div class="point__avatar"><img src="assets/img/content/user_02.png" class="img-fluid" alt=""></div>' +
                '<div class="point__content">' +
                '<div class="point__name">Турсунханов Н.В.</div>' +
                '</div>' +
                '</div>'
            );

            let user_2 = new ymaps.Placemark(
                [55.7660,37.6051], {
                    hintContent: 'Турсунханов Н.В.'
                }, {
                    iconLayout: userLayout_2,
                    iconShape: {
                        type: 'Rectangle',
                        coordinates: [
                            [-25, -25], [25, 25]
                        ]
                    }
                }
            );

            let userLayout_3 = ymaps.templateLayoutFactory.createClass('<div class="point">' +
                '<div class="point__avatar"><img src="assets/img/content/user_03.png" class="img-fluid" alt=""></div>' +
                '<div class="point__content">' +
                '<div class="point__name">Оспанов Б.Ш.</div>' +
                '<div class="point__icon"><i class="bx bx-lock-alt"></i></div>' +
                '</div>' +
                '</div>'
            );

            let user_3 = new ymaps.Placemark(
                [55.7689,37.6288], {
                    hintContent: 'Оспанов Б.Ш.'
                }, {
                    iconLayout: userLayout_3,
                    iconShape: {
                        type: 'Rectangle',
                        coordinates: [
                            [-25, -25], [25, 25]
                        ]
                    }
                }
            );

            let userLayout_4 = ymaps.templateLayoutFactory.createClass('<div class="point point--red">' +
                '<div class="point__avatar"><img src="assets/img/content/user_04.png" class="img-fluid" alt=""></div>' +
                '<div class="point__content">' +
                '<div class="point__name">Алиев С.Г.</div>' +
                '<div class="point__icon"><span class="d-inline-block">!</span></div>' +
                '</div>' +
                '</div>'
            );

            let user_4 = new ymaps.Placemark(
                [55.7755,37.6221], {
                    hintContent: 'Алиев С.Г.'
                }, {
                    iconLayout: userLayout_4,
                    iconShape: {
                        type: 'Rectangle',
                        coordinates: [
                            [-25, -25], [25, 25]
                        ]
                    }
                }
            );

            let userLayout_5 = ymaps.templateLayoutFactory.createClass('<div class="point point--red point--selected">' +
                '<div class="point__avatar"><img src="assets/img/content/user_05.png" class="img-fluid" alt=""></div>' +
                '<div class="point__content">' +
                '<div class="point__name">Ахметов С.Г.</div>' +
                '<div class="point__icon"><span>!</span></div>' +
                '</div>' +
                '</div>'
            );

            let user_5 = new ymaps.Placemark(
                [55.7779,37.6026], {
                    hintContent: 'Ахметов С.Г.'
                }, {
                    iconLayout: userLayout_5,
                    iconShape: {
                        type: 'Rectangle',
                        coordinates: [
                            [-25, -25], [25, 25]
                        ]
                    }
                }
            );

            map.geoObjects.add(user_1);
            map.geoObjects.add(user_2);
            map.geoObjects.add(user_3);
            map.geoObjects.add(user_4);
            map.geoObjects.add(user_5);

        });

        function drawLineOverMap(map) {
            let canvas = document.querySelector('#draw-canvas');
            let ctx2d = canvas.getContext('2d');
            let drawing = false;
            let coordinates = [];

            // Задаем размеры канвасу как у карты.
            let rect = map.container.getParentElement().getBoundingClientRect();
            canvas.style.width = rect.width + 'px';
            canvas.style.height = rect.height + 'px';
            canvas.width = rect.width;
            canvas.height = rect.height;

            // Применяем стили.
            ctx2d.strokeStyle = canvasOptions.strokeStyle;
            ctx2d.lineWidth = canvasOptions.lineWidth;
            canvas.style.opacity = canvasOptions.opacity;

            ctx2d.clearRect(0, 0, canvas.width, canvas.height);

            // Показываем канвас. Он будет сверху карты из-за position: absolute.
            canvas.style.display = 'block';

            canvas.onmousedown = function(e) {
                // При нажатии мыши запоминаем, что мы начали рисовать и координаты.
                drawing = true;
                coordinates.push([e.offsetX, e.offsetY]);
            };

            canvas.onmousemove = function(e) {
                // При движении мыши запоминаем координаты и рисуем линию.
                if (drawing) {
                    var last = coordinates[coordinates.length - 1];
                    ctx2d.beginPath();
                    ctx2d.moveTo(last[0], last[1]);
                    ctx2d.lineTo(e.offsetX, e.offsetY);
                    ctx2d.stroke();

                    coordinates.push([e.offsetX, e.offsetY]);
                }
            };

            return new Promise(function(resolve) {
                // При отпускании мыши запоминаем координаты и скрываем канвас.
                canvas.onmouseup = function(e) {
                    coordinates.push([e.offsetX, e.offsetY]);
                    canvas.style.display = 'none';
                    drawing = false;

                    coordinates = coordinates.map(function(x) {
                        return [x[0] / canvas.width, x[1] / canvas.height];
                    });

                    resolve(coordinates);
                };
            });
        }

        // Метод IPolygonGeometryAccess
        let myPolygon = new ymaps.geometry.Polygon([
            [
                [55.7721,37.6202],
                [68, 55],
                [86, 56]
            ]
        ]);

        // Метод работает только с корректно заданной картой.
        myPolygon.options.setParent(myMap.options);
        myPolygon.geometry.setMap(myMap);

        // Проверка, входит ли точка клика в полигон, с заданной выше геометрией.
        myMap.events.add('click', function(e) {
            alert(myPolygon.geometry.contains(e.get('#draw-canvas')) ? 'Успешно' : 'Еще раз');
        });
    </script>

{% endblock %}
